# -*- coding: utf-8 -*-

# Copyright (C) 2009  Mark McCans <mjmccans@gmail.com>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

from PyQt4.QtCore import *
from PyQt4.QtGui import *

class PopupDialog(QWidget):
   def init(self):
      QWidget.__init__(self,parent=None)
      self.setWindowFlags(Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint | Qt.X11BypassWindowManagerHint)

      layout = QVBoxLayout(self)
      self.title = QLabel()
      self.title.setAlignment(Qt.AlignCenter)
      layout.addWidget(self.title)
      self.body = QLabel()
      layout.addWidget(self.body)

      self.setLayout(layout)
      self.scr = None
      self.moved = False #Prevent future movement, only let it be moved once, else it wants to jump back to 0,0 for some odd reason
   
   def event(self,event):
      if event.type() == QEvent.MouseButtonPress:
         self.hide()
         return True
      return False
      
   def moveMe(self):
      if self.scr == None:
         scr = QApplication.desktop().screenGeometry()
      rect = self.normalGeometry()
      newPoint = scr.bottomRight() - rect.bottomRight()
      newPoint.setY(newPoint.y() - 50)
      newPoint.setX(newPoint.x() - 20)
      self.move(newPoint)
      
   def setTitle(self, s):
        if s == "":
            self.title.setText("")
        else:
            self.title.setText("<b>"+s+"</b>")
        
   def setBody(self, s):
        self.body.setText(s)
        
   def showDialog(self):
      if self.title.text() == "" and self.body.text() == "":
         pass
      if not self.isVisible():
         self.show()
         if not self.moved:
            self.moveMe()
            self.moved=True
            