from PyQt4 import QtGui,QtCore
from PyQt4.QtGui import *
from PyQt4.QtCore import *
import statusimages, pytz, StringIO, pycurl, sys, urllib, re
from pytz import timezone
from datetime import datetime
from Dialog import *

class SystemTrayIcon(QtGui.QSystemTrayIcon):
   def __init__(self,icon,parent=None):
      self.greenIcon = QIcon(QPixmap(":/colors/green.png"))
      self.green12Icon = QIcon(QPixmap(":/colors/green12.png"))
      self.green25Icon = QIcon(QPixmap(":/colors/green25.png"))
      self.green37Icon = QIcon(QPixmap(":/colors/green37.png"))
      self.green50Icon = QIcon(QPixmap(":/colors/green50.png"))
      self.green62Icon = QIcon(QPixmap(":/colors/green62.png"))
      self.green75Icon = QIcon(QPixmap(":/colors/green75.png"))
      self.green87Icon = QIcon(QPixmap(":/colors/green87.png"))
      self.yellowIcon = QIcon(QPixmap(":/colors/yellow.png"))
      self.orangeIcon = QIcon(QPixmap(":/colors/orange.png"))
      self.grayIcon = QIcon(QPixmap(":/colors/gray.png"))
      self.sapphireIcon = QIcon(QPixmap(":/colors/sapphire.png"))
      QtGui.QSystemTrayIcon.__init__(self,self.sapphireIcon,parent)
      menu = QtGui.QMenu(parent)
      self.useTokenAction = QAction("Restore Bandwidth With Token",self)
      self.useTokenAction.triggered.connect(self.tryToToken)
      exitAction = QAction("Exit",self)
      exitAction.triggered.connect(sys.exit)
      menu.addAction(exitAction)
      menu.addAction(self.useTokenAction)
      self.useTokenAction.setEnabled(False)
      self.setContextMenu(menu)
      self.Dialog = PopupDialog()
      self.Dialog.init()
      self.activated.connect(self.trayActivated)

      self.setUserMessage("Hughesnet Status","Applet Started")
      self.san = self.getSAN()

   def trayActivated(self,reason):
      if reason == QSystemTrayIcon.Trigger:
         self.showDialog()
      
   def updateUi(self,current_status,download_current,download_allowance,refill,refill_amount):
      percentage = float(download_current)/float(download_allowance) * 100
      status_message = {}
      status_message['gray'] = "Could not reach modem"
      status_message['green'] = "OK"
      status_message['red'] = "Down"
      status_message['orange'] = "Fapped"
      status_message['yellow'] = "Degraded"
      status_message['sapphire'] = 'Free time'
      if current_status == "green":
         if percentage >= 93:
            self.setIcon(self.greenIcon)
         elif percentage >= 81:
            self.setIcon(self.green87Icon)
         elif percentage >= 69:
            self.setIcon(self.green75Icon)
         elif percentage >= 56:
            self.setIcon(self.green62Icon)
         elif percentage >= 44:
            self.setIcon(self.green50Icon)
         elif percentage >= 31:
            self.setIcon(self.green37Icon)
         elif percentage >= 19:
            self.setIcon(self.green25Icon)
         elif percentage >= 6.25:
            self.setIcon(self.green12Icon)
         else:
            self.setIcon(self.grayIcon)
      elif current_status == "red":
         self.setIcon(self.redIcon)
      elif current_status == "orange":
         self.setIcon(self.yellowIcon)
      elif current_status == "orange":
         self.setIcon(self.orangeIcon)
         
         download_remaining = 0
         percent = 0
      else:
         self.setIcon(self.grayIcon)
         
      utc = pytz.utc
      eastern = timezone('US/Eastern')

      native_time = datetime.utcnow()
      utc_time = utc.localize(datetime(native_time.year,native_time.month,native_time.day,native_time.hour,native_time.minute,native_time.second))
      eastern_time = utc_time.astimezone(eastern)
      

      if 2 <= eastern_time.hour < 7:
         if current_status == 'green':
               current_status = 'sapphire'
               self.setIcon(self.sapphireIcon)
      self.setUserMessage("Hughesnet Status","Status: %s\nPlan Allowance: %s\nPlan Remaining: %s\nNext Refill: %s\nRefill Amount: %s" % (status_message[str(current_status)],download_allowance,download_current,refill, refill_amount))
      
      if current_status == 'orange':
         self.enableToken(True)
      else:
         self.enableToken(False)
   
   def tryToToken(self):
      complimentary_available = 0 #number of free tokens available
      paid_available = 0          #number of paid tokens available
      
      buf1 = StringIO.StringIO()
      temp_cookie_file = tempfile.NamedTemporaryFile(prefix='test',delete=False)
      c = pycurl.Curl()
      c.setopt(pycurl.VERBOSE,True)
      c.setopt(pycurl.URL,"http://services.hughesnet.com/service_tools/tokens/check.cfm")
      c.setopt(pycurl.WRITEFUNCTION, buf1.write)
      zipcode = QInputDialog.getText(this,"Zipcode Entry","Please enter your zip code:")
      c.setopt(pycurl.POSTFIELDS,"zipcode=%s&san=%s&press=%20OK%20" % (zipcode,self.san))
      c.setopt(pycurl.COOKIEFILE, temp_cookie_file.name)
      c.setopt(pycurl.COOKIEJAR, temp_cookie_file.name)
      c.setopt(pycurl.POST,1)
      
      c.perform()
      html_soup = buf1.getvalue()
      buf1.close()
      
      html_soup = re.sub('<.*?>','\n',html_soup)
      html_soup = re.sub('&nbsp;',' ',html_soup)
      html_soup = re.sub('\s{2,}','\n',html_soup)
      html_parsed = html_soup.split('\n')
      x = 0
      while x < len(html_parsed):
         if html_parsed[x] == "Complimentary":
            complimentary_available = html_parsed[x+3]
         elif html_parsed[x] == "Use Pre-Paid Token":
            paid_available = html_parsed[x+2]
         
         ##prefer complimentary
      
      token_type = 0
      if complimentary_available > 0:
         token_type = 1
      elif paid_available > 0:
         token_type = 2
         
      buf2 = StringIO.StringIO()
      if token_type > 0:
         c.setopt(pycurl.WRITEFUNCTION,buf2.write)
         c.setopt(pycurl.URL,"http://services.hughesnet.com/service_tools/tokens/use.cfm")
         c.setopt(pycurl.POSTFIELDS,"tokentype=%s&quantity=0&press=%20OK%20" % token_type)
         c.perform()
         c.close()
      buf2.close()
      
   def enableToken(self, boo):
      self.useTokenAction.setEnabled(boo)
      
   def setUserMessage(self, s1, s2=""):
      # Update the hover dialog to give user information
      self.Dialog.setTitle(s1)
      self.Dialog.setBody(s2)
      self.Dialog.update()

   def showDialog(self):
      #self.Dialog.move(self.popupPosition(self.Dialog.sizeHint()))
      self.Dialog.showDialog()
      
   def getSAN(self):
      fap_soup = False
      try:
         fap_soup = urllib.urlopen('http://192.168.0.1/stlui/user/system_info.html?Cagw=0').read()
         
      except:
         fap_soup = False # Just to be sure ...
      
      if fap_soup != False:
         fap_soup = re.sub('<.*?>','\n',fap_soup)
         fap_soup = re.sub('&nbsp;',' ',fap_soup)
         fap_soup = re.sub('\s{2,}','\n',fap_soup)
         fap_parsed = fap_soup.split('\n')
         x = 0
         while x < len(fap_parsed):
            if fap_parsed[x] == "ST Name":
               print(fap_parsed[x+1])
               return fap_parsed[x+1]
            x = x +1